<?php
namespace nur\sery\wip\schema\types;

use nulib\tests\TestCase;
use nur\sery\wip\schema\_scalar\ScalarWrapper;
use nur\sery\wip\schema\Schema;

class unionTest extends TestCase {
  function testUnionTypes() {
    ## l'ordre des types doit être respecté
    
    # string puis int
    /** @var ScalarWrapper $siv */
    Schema::nw($si, null, $sis, "string|int", $siv);

    $siv->set("12");
    self::assertSame("12", $si);
    $siv->set(12);
    self::assertSame(12, $si);

    # int puis string
    Schema::nw($is, null, $iss, "int|string", $isv);

    $isv->set("12");
    self::assertSame("12", $is);
    $isv->set(12);
    self::assertSame(12, $is);
  }
}
